
/*SCI0@\g߂̍Œ@\łł*/
/* ------------------------------------------------- */
/* SCI0 INITIALIZATION fixed baud at 38400           */
/* ------------------------------------------------- */
void initSCI0()
{
	short int i;
	/*unsigned char dummy;*/
	SCI0.SCR.BYTE = 0;       /* clear all flags */
					  /* 2400-38400baud are available at n=0(cks1=0,cks2=0) */
	SCI0.SMR.BYTE = 0;       /* Ascnc, 8bit , NoParity, stop1, 1/1 */
	SCI0.BRR = 12;          /* 38400baud (CPU=16MHz) */
	for(i=0;i<1000;i++);      /* wait more than 1bit time */
	SCI0.SCR.BYTE = 0x30;    /* scr = 0011 0000 (TE=1,RE=1) */
	/*dummy = SCI0.SSR.BYTE;*/   /* read dummy             ????*/
	/*SCI0.SSR.BYTE = 0x80;*/  /* clear error flag (TDRE = 1)     ????*/
	return;
}

/* ------------------------------------------------- */
/* GET BYTE FROM SCI0 */
/* ------------------------------------------------- */
short int getCharSCI0()
/* return value 0x00-0xFF:received data */
/*              -2(0xFFFE):error */
{
	short int flags,recdata;
	do {
		flags = SCI0.SSR.BYTE;
		if (flags&0x38) {/* error */
			SCI0.SSR.BIT.RDRF = 0;
			SCI0.SSR.BIT.ORER = 0;
			SCI0.SSR.BIT.FER = 0;
			SCI0.SSR.BIT.PER = 0;
			return -2;
		}
		if (flags&0x40) {/* normally received one data */
			SCI0.SSR.BIT.RDRF = 0;
			recdata=SCI0.RDR;
			return recdata;
		}
	} while (1);
}

/* ------------------------------------------------- */
/* CHECK SCI BUFFER AND GET DATA */
/* ------------------------------------------------- */
short int chkgetCharSCI0()
/* return value -1(0xFFFF):no received data  */
/*              0x00-0xFF:received data */
/*              -2(0xFFFE):error */
{
	short int flags,recdata;
	flags = SCI0.SSR.BYTE;
	if (flags&0x38) {/* error */
		SCI0.SSR.BIT.RDRF = 0;
		SCI0.SSR.BIT.ORER = 0;
		SCI0.SSR.BIT.FER = 0;
		SCI0.SSR.BIT.PER = 0;
		return -2;
	}
	if (flags&0x40) {/* normally received one data */
		recdata=SCI0.RDR;
		SCI0.SSR.BIT.RDRF = 0;
		return recdata;
	} else {
		return -1;
	}
}


/*SCI0蕶͂CbuffɍڂĕԂ*/
/*[return]='\r'I[ƂB'\r','\n'͎擾Ȃ*/
/*VAʐMł͉sƂ'\r'gĂ邱Ƃɑ΂Ή*/
/*^H̓obNXyCXƂĎ󂯎*/
/*󂯎Ԃ*/
/*󂯎pbuff͌ĂяoŊmۂĂ*/
/*maxbuff̃TCYC\蕶{1ȏɂ邱*/
int getStringSCI0(char *buff,int max)
{
	int i,ch;
	for (i=0;i<max-1;i++) {
		ch=getCharSCI0(); /*1擾*/
		*buff=(char)ch; /*1擾*/
		if (*buff=='\r'||ch<0) {
			*buff=0;
			return i+1;
		}
		if (*buff==0x8) {
			buff-=2;
			i-=2;
		}
		if (*buff!='\n') buff++;
		else i--;
	}
	*buff=0;
	return i+1;
}

/* ------------------------------------------------- */
/* PUT BYTE TO SCI0 */
/* ------------------------------------------------- */
/*bytef[^͂̂܂SCI0ɏo͂*/
void putByteSCI0(char c)
{
	unsigned char tmp;
	do{
		tmp = SCI0.SSR.BYTE;
	} while((tmp & 0x80)==0);
	SCI0.TDR = c;
	SCI0.SSR.BIT.TDRE = 0;
	return;
}

/* ------------------------------------------------- */
/* PUT CHAR TO SCI0 */
/* ------------------------------------------------- */
/*'\n''\r'ɕϊSCI0ɏo͂*/
/*VAʐMł͉sƂ'\r'gĂ邱Ƃɑ΂Ή*/
void putCharSCI0(char c)
{
	unsigned char tmp;
	if (c=='\n') putCharSCI0('\r');
	do{
		tmp = SCI0.SSR.BYTE;
	} while((tmp & 0x80)==0);
	SCI0.TDR = c;
	SCI0.SSR.BIT.TDRE = 0;
	return;
}

/*'\0'ŏI镶o*/
void putStringSCI0(char *str)
{
	while(*str){
		putCharSCI0(*str);
		str++;
	}
}
